void Init() {
}
void SetParameters() {
	params.AddString("Knock back force Min", "1000"); //The minimum knock back force.
	params.AddString("Knock back force Max", "30000"); //The maximum knock back force.
	params.AddString("Damage with each shot", "0.4");	//The amount of damage applied to the target with each shot.
	params.AddString("Friendly", "1");	//Whether the turret doesn't shoots the player.
	params.AddString("Turret head ID number", "1001");	//Change this number if you want more than one turret.
}

void HandleEvent(string event, MovementObject @mo){
    if(event == "enter"){
        OnEnter(mo);
    } 
	else if(event == "exit"){
        OnExit(mo);
    }
}
void OnEnter(MovementObject @mo) {
	if (params.GetFloat("Friendly") ==  1){
		if(!mo.controlled){
			Shoot(mo);
		}
	}
	else{
		Shoot(mo);
	}

}
void OnExit(MovementObject @mo) {
	
	}
void Shoot(MovementObject @mo){
	string body_part;
	int random_picker = RangedRandomFloat(0,4);	//This case switch picks a random body part to shoot.
	switch(random_picker){
		case 0: body_part = "head"; break;
		case 1: body_part = "leftarm";  break;
		case 2: body_part = "rightarm";  break;
		case 3: body_part = "left_leg";  break;
		case 4: body_part = "right_leg"; break;
		}
	vec3 player_pos = mo.rigged_object().GetIKChainPos(body_part,0);
	Object@ turret_obj = ReadObjectFromID(params.GetFloat("Turret head ID number"));
	vec3 turret_pos = turret_obj.GetTranslation();
	vec3 distance = player_pos - turret_pos;
	
	//This could be used to compensate for the character movement. So that the bullet hits the target even if the target moves fast or slowly. Does not work currently.
	//vec3 player_pos(mo.rigged_object().GetIKChainPos(body_part,0).x+(mo.velocity.x/2),mo.rigged_object().GetIKChainPos(body_part,0).y+(mo.velocity.y/2),mo.rigged_object().GetIKChainPos(body_part,0).z+(mo.velocity.z/2));
	
	mat4 turret_head_rotation;
	//turret_head_rotation.SetRotationX(asin(-distance.y)); //The up and down movement of the turret doesn't seem to work, math is hard.
	turret_head_rotation.SetRotationY(atan2(-distance.x, -distance.z));
	turret_obj.SetRotation(QuaternionFromMat4(turret_head_rotation));
	
	MakeParticle("Data/Custom/gyrth/turret/Scripts/bullet.xml", (turret_pos + ((player_pos - turret_pos) * 0.2f)), distance);	//The extra 0.2 is so that the particle spawns in front of the turret.
	MakeParticle("Data/Custom/gyrth/turret/Scripts/muzzle_flash.xml", (turret_pos + ((player_pos - turret_pos) * 0.2f)), distance);	//This is because the particles collide, and if they spawned inside the turret they would collide inside the turret.
	MakeParticle("Data/Custom/gyrth/turret/Scripts/muzzle_smoke.xml", (turret_pos + ((player_pos - turret_pos) * 0.2f)), distance);
	
	vec3 force = normalize(player_pos - turret_pos) * RangedRandomFloat(params.GetFloat("Knock back force Min"),params.GetFloat("Knock back force Max"));
	PlaySound("Data/Custom/gyrth/turret/Sounds/gunshot2.wav", turret_pos);	//Pew
	mo.Execute("vec3 impulse = vec3("+force.x+", "+force.y+", "+force.z+");" +
			"GoLimp();" +	//Comment this line if you don't want an impact, but don't jump.
			"this_mo.rigged_object().ApplyForceToRagdoll(impulse, this_mo.rigged_object().GetAvgIKChainPos(\""+body_part+"\"));" + 
			"TakeDamage("+ params.GetFloat("Damage with each shot") +");" +
			"ragdoll_limp_stun = 0.9f;"+
			"recovery_time = 2.0f;");
}